// adxcut.h
// Ŭ˥饹

//
// adxcut.cpp
//DC KanonϢadx
//
// adxcut afsfilename
//
#include <sys/stat.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <unistd.h>
#include "adxcut.h"
#include "EncoderProtocol.h"

#ifndef _MAX_PATH
#define _MAX_PATH 1024
#endif

#define BASEVOL 0x25e0

#define INLINE inline

// error quit
void
Cadxcut::errorexit(char* arg1,char* arg2){
  //fprintf(stderr,"%s : %s\n",arg1,arg2);
  fclose(in);
  exit(1);
}

int
Cadxcut::adxcut(const char *filename,const char *distpath,int wavtype,int game,int isMixer, int brate, id <ControllerProtocol>controller, Class enc)
{
	int i;
	unsigned long tmp;
  struct{
    char identifier[4];
    long n;
  } afs_head;

  struct DataIndex{
    long offset;
    long size;
  } *index;
  char path[_MAX_PATH];
  char filenamebuf[_MAX_PATH];
  char letter[5];
  char ext[4];
  const char* ptr;

  type=wavtype;
  bitrate = brate;
  encoder = enc;

  if ((in=fopen(filename,"rb"))==NULL) {
    printf("can't find AFS file %s.\n",filename);
    return -1;
  }

  fread(&afs_head,4,1,in);
  if (strcmp(afs_head.identifier,"AFS")){
    // AFS¤ʤ
    printf("file %s is not an AFS file.\n",filename);
    return -1;
  }

  // ʬȤؤΥѥ
  // Ÿ򤽤Τˡ

  ptr=filename+strlen(filename)-1;
  while(ptr>filename && *ptr!='.') ptr--;
  if(game == 0) {
	if(isMixer == 0) {
		letter[0] = *(ptr-1);
		letter[1] = '\0';
	}
	else {
		if(*(ptr-1) == 'A' || *(ptr-1) == 'a') strcpy(letter,"1100");
		else if(*(ptr-1) == 'B' || *(ptr-1) == 'b') strcpy(letter,"1110");
		else {
			letter[0] = '1';
			letter[1] = '0';
			letter[2] = *(ptr-1);
			letter[3] = '0';
			letter[4] = '\0';
		}
	}
  }
  else {
	if(isMixer == 0) {
		letter[0] = *(ptr-2);
		letter[1] = *(ptr-1);
		letter[2] = '\0';
	}
	else {
		letter[0] = '1';
		letter[1] = *(ptr-2);
		letter[2] = *(ptr-1);
		letter[3] = '\0';
	}
  }
  sprintf(path,"%s/%s/",distpath,letter);
  mkdir(path,0755); // ǥ쥯ȥ
  //fprintf(stderr,"filenum : %d\n",filenum);
  
	fread(&tmp,4,1,in);
	afs_head.n =  tmp>>24 | (tmp&0xff0000)>>8 | (tmp&0xff00)<<8 | tmp<<24;
	//printf("%d\n",afs_head.n);
	
  index=new struct DataIndex [afs_head.n];

	for(i=0;i<afs_head.n;i++){
		fread(&tmp,4,1,in);
		index[i].offset = tmp>>24 | (tmp&0xff0000)>>8 | (tmp&0xff00)<<8 | tmp<<24;
		fread(&tmp,4,1,in);
		index[i].size = tmp>>24 | (tmp&0xff0000)>>8 | (tmp&0xff00)<<8 | tmp<<24;
	}    
	[controller setProgressMaxValue2: (double)afs_head.n];
	
	if(type == 0) strcpy(ext,"wav");
	else strcpy(ext,"mp3");
	
  for(i=0;i<afs_head.n;i++){
    unsigned char *buffer;
    // ե̾
	if(game == 0) {
		if(isMixer == 0) sprintf(filenamebuf,"%s%04x.%s",path,i,ext);
		else sprintf(filenamebuf,"%sZ%s%04d.%s",path,letter,i+1,ext);
	}
	else
	{
		if(isMixer == 0) sprintf(filenamebuf,"%s%04x.%s",path,i,ext);
		else sprintf(filenamebuf,"%sZ%s%05d.%s",path,letter,i+1,ext);
	}
    //		fprintf(stderr,"%s",filenamebuf,adxsize);
    /*
      printf("%3d(0x%03x): offset=%09ld(0x%08lx) size=%06ld(0x%05lx)\n",
	     i,i,index[i].offset,index[i].offset,
	     index[i].size,index[i].size);
    */
		// ɤ
    buffer= new unsigned char [index[i].size];
    fseek(in,index[i].offset,SEEK_SET); // ϥե볫ϰ֤
    fread(buffer,sizeof(char),index[i].size,in);
		if(access(filenamebuf,F_OK) != 0) {
			if(type == 0) outconvedwav(filenamebuf,buffer,index[i].size); // СȤƽ񤭽Ф
			else outconvedmp3(filenamebuf,buffer,index[i].size,encoder);
		}
			
    
    delete [] buffer; // ⤦ʤ
	[controller addProgress2];
    //putchar('*');
    //fflush(stdout);
  }
  //putchar('\n');
  delete [] index;

  fclose(in);
  
  return 0;
}

INLINE long Cadxcut::getlong(unsigned char *d){
  return
    (((long)(d[0])<<24) |((long)(d[1])<<16) | 
     ((long)(d[2])<<8 ) |((long)(d[3])    ) );
}

INLINE short Cadxcut::getshort(unsigned char *d){
  return ((short)(d[0])<<8 | (short)(d[1]));
}

// adxˤե륤᡼ǥɤwavե˽񤭽Ф
int
Cadxcut::outconvedwav(char *filename,unsigned char *adx,int size)
{
  FILE* fp;
  fp=fopen(filename,"wb");

  static int rate_check;
  long riffsizeptr,datasizeptr;

  int a,n,x,y,z;
  a=n=x=y=z=0;
	
	int rate = getlong(adx+8);
	int samplenum = getlong(adx+12);

	short temp;
	unsigned short tmp2;
	unsigned int tmp;
  int output_sample=0;
  int outputdatanum=0;
	
	adx += getshort(adx+2)+4; // ǡϰ֤

  if(! rate_check && rate != 22050){
    printf("sampling rate of AFS file is not 22.05kHz.\n");
    rate_check++;
  }

  { // إå
    fwrite("RIFF",sizeof(char),4,fp);
    int riffsize = size+36; // ʲΥ
		riffsizeptr=ftell(fp);
		tmp = riffsize>>24 | (riffsize&0xff0000)>>8 | (riffsize&0xff00)<<8 | riffsize<<24;
    fwrite(&tmp,sizeof(int),1,fp); // 
    
    fwrite("WAVE",sizeof(char),4,fp);
    
    fwrite("fmt ",sizeof(char),4,fp); //fmt  16
		int fmtSize = 16;
		tmp = fmtSize>>24 | (fmtSize&0xff0000)>>8 | (fmtSize&0xff00)<<8 | fmtSize<<24;
    fwrite(&tmp,sizeof(int),1,fp);

    short datatype=1; //PCM
    short channel=1;  //mono

    short bitpersample = 16; //16bits
		
		tmp2 = datatype >> 8 | datatype << 8;
    fwrite(&tmp2,sizeof(short),1,fp);
		
		tmp2 = channel >> 8 | channel << 8;
    fwrite(&tmp2,sizeof(short),1,fp);
		
		tmp = rate>>24 | (rate&0xff0000)>>8 | (rate&0xff00)<<8 | rate<<24;
    fwrite(&tmp,sizeof(int),1,fp);
		
		int Bpsec = rate*channel*bitpersample/8;
		tmp = Bpsec>>24 | (Bpsec&0xff0000)>>8 | (Bpsec&0xff00)<<8 | Bpsec<<24;
    fwrite(&tmp,sizeof(int),1,fp);

		short blocksize = bitpersample/8*channel;
		tmp2 = blocksize >> 8 | blocksize << 8;
    fwrite(&tmp2,sizeof(short),1,fp);
		
		tmp2 = bitpersample >> 8 | bitpersample << 8;
    fwrite(&tmp2,sizeof(short),1,fp);
	
    fwrite("data",sizeof(char),4,fp); // data  size+8
		datasizeptr=ftell(fp);
		tmp = riffsize>>24 | (riffsize&0xff0000)>>8 | (riffsize&0xff00)<<8 | riffsize<<24;
    fwrite(&tmp,sizeof(int),1,fp); //
  }

  while(output_sample<samplenum){
    n=getshort(adx);
    adx+=2;
    for(int j=0;j<16;j++){
      //
			a=adx[j]>>4;
      if(a & 8) a-=16;
			x=temp=(BASEVOL*a*n + 0x7298*y - 0x3350*z)>>14;
			tmp2 = (temp&0x0000ffff) >> 8 | (temp&0x0000ffff) << 8;
      fwrite(&tmp2,sizeof(short),1,fp); outputdatanum++; // 
      z=y; y=x;

      /*
      x=temp=(BASEVOL*n*a*2 + 0x7298*y - 0x3350*z)>>14;
      if (type==1){
	fwrite(&temp,sizeof(short),1,fp); outputdatanum++; // 44k
      }
      z=y; y=x;
      */
      output_sample++;

      //ao=a;

      //
			a=adx[j] & 15;
      if(a & 8) a-=16;
 
			x=temp=(BASEVOL*a*n + 0x7298*y - 0x3350*z)>>14;
			tmp2 = (temp&0x0000ffff) >> 8 | (temp&0x0000ffff) << 8;
      fwrite(&tmp2,sizeof(short),1,fp); outputdatanum++; // 
      z=y; y=x;

      /*
      x=temp=(BASEVOL*n*a*2 + 0x7298*y - 0x3350*z)>>14;
      if (type==1){
	fwrite(&temp,sizeof(short),1,fp); outputdatanum++; // 44k
      }
      z=y; y=x;
      */
      output_sample++;

      //ao=a;
    }
    adx+=16;
  }
  int datasize=outputdatanum*2;
	fseek(fp,datasizeptr,SEEK_SET);
	tmp = datasize>>24 | (datasize&0xff0000)>>8 | (datasize&0xff00)<<8 | datasize<<24;
  fwrite(&tmp,sizeof(int),1,fp); //ܽ

  int riffsize=datasize+36;
	fseek(fp,riffsizeptr,SEEK_SET);
	tmp = riffsize>>24 | (riffsize&0xff0000)>>8 | (riffsize&0xff00)<<8 | riffsize<<24;
  fwrite(&tmp,sizeof(int),1,fp); //ܽ

  fclose(fp);

  return riffsize;
}

int
Cadxcut::outconvedmp3(char *filename,unsigned char *adx,int size,Class encoderClass)
{
  //FILE* fp;

  static int rate_check;

  int a,n,x,y,z;
  a=n=x=y=z=0;
	
	int rate = getlong(adx+8);
	int samplenum = getlong(adx+12);
	
	id <EncoderProtocol>encoder;

	short temp;
	short *pcm;
	//unsigned char *mp3buffer;
  int output_sample=0;
	int outputdatanum=0;
	//int imp3;
	
	adx += getshort(adx+2)+4; // ǡϰ֤

  if(! rate_check && rate != 22050){
    printf("sampling rate of AFS file is not 22.05kHz.\n");
    rate_check++;
  }
	
	pcm = malloc(samplenum * 2);
	
  while(output_sample<samplenum){
    n=getshort(adx);
    adx+=2;
    for(int j=0;j<16;j++){
      //
			a=adx[j]>>4;
      if(a & 8) a-=16;
			x=temp=(BASEVOL*a*n + 0x7298*y - 0x3350*z)>>14;
      pcm[outputdatanum]=temp; outputdatanum++; // 
      z=y; y=x;

      /*
      x=temp=(BASEVOL*n*a*2 + 0x7298*y - 0x3350*z)>>14;
      if (type==1){
	fwrite(&temp,sizeof(short),1,fp); outputdatanum++; // 44k
      }
      z=y; y=x;
      */
      output_sample++;

      //ao=a;

      //
			a=adx[j] & 15;
      if(a & 8) a-=16;
 
			x=temp=(BASEVOL*a*n + 0x7298*y - 0x3350*z)>>14;
      pcm[outputdatanum]=temp; outputdatanum++; // 
      z=y; y=x;

      /*
      x=temp=(BASEVOL*n*a*2 + 0x7298*y - 0x3350*z)>>14;
      if (type==1){
	fwrite(&temp,sizeof(short),1,fp); outputdatanum++; // 44k
      }
      z=y; y=x;
      */
      output_sample++;

      //ao=a;
    }
    adx+=16;
  }
	/*
	lame_global_flags *lameflag;
	
	lameflag = lame_init();
	
	lame_set_num_samples(lameflag, output_sample-20);
	lame_set_in_samplerate(lameflag, 22050);
	lame_set_num_channels(lameflag, 1);
	lame_set_quality(lameflag, 5);
	lame_set_brate(lameflag, bitrate);
	int ret = lame_init_params(lameflag);
	if(ret == -1) {
		printf("lame init error\n");
		exit(0);
	}
	int buffersize = (int)(output_sample*(bitrate*1000/8)/22050 + 4*576*(bitrate*1000/8)/22050 + 256);
	mp3buffer = malloc((unsigned long)buffersize);
	
	fp=fopen(filename,"wb");
	
	imp3 = lame_encode_buffer(lameflag, pcm, NULL, output_sample-20,
			mp3buffer, buffersize);
	
	if (imp3 < 0) {
		if (imp3 == -1)
				fprintf(stderr, "mp3 buffer is not big enough... \n");
		else
				fprintf(stderr, "mp3 internal error:  error code=%i\n", imp3);
		return 1;
	}
	
	fwrite(mp3buffer, 1, imp3, fp);
	
	
	imp3 = lame_encode_flush(lameflag, mp3buffer, buffersize);
	
	if (imp3 < 0) {
		if (imp3 == -1)
				fprintf(stderr, "mp3 buffer is not big enough... \n");
		else
				fprintf(stderr, "mp3 internal error:  error code=%i\n", imp3);
		return 1;
	}
	
	fwrite(mp3buffer, 1, imp3, fp);
	fclose(fp);
	
	lame_close(lameflag);
	free(mp3buffer);
	free(pcm);
	*/
	
	encoder = [[encoderClass alloc] initWithFile: filename];
	int ret = [encoder setSampleNum:output_sample-20 sampleRate:22050 channel:1 quality:5 bitRate:bitrate];
	if(ret == -1) {
		printf("lame init error\n");
		[encoder release];
		exit(0);
	}
	
	ret = [encoder startEncodeWithPCMBuffer: pcm];
	if (ret < 0) {
		if (ret == -1)
				fprintf(stderr, "mp3 buffer is not big enough... \n");
		else
				fprintf(stderr, "mp3 internal error:  error code=%i\n", ret);
		[encoder release];
		return 1;
	}
	[encoder release];

  return 0;
}
